/*
		es.h
		Funciones de entrada/salida para el audio. Encapsula varias de las funcioens
		de sndlib para hacer ms facil el trabajo al abrir un archivo.

		Prefijos:
		Obt: para funciones que obtienen datos
		Asig: para funciones que asignan datos
		Impr: para funciones que imprimen datos en pantalla
*/



/* 
	chequea que la entrada de la lnea de comandos tenga el nmero de argumentos necesarios.
	Es una funcin general para todas las aplicaciones.

	args : la cantidad de argumentos que el usuario ingres.
	nargs : la cantidad argumentos necesarios para correr sta aplicacin.
	msj : el mensaje que se va a mostrar, dependiendo de la aplicacin.
	nomb_exe : nombre del ejecutable de sta aplicacin.
*/
int ChequearEntrada(int args, int nargs, char *msj, char *nomb_exe)
{
  if(args < nargs) 
		{
    fprintf(stderr, "\n  %s: Insuficientes argumentos [%d] \n  %s", nomb_exe, args, msj);
    fprintf(stdout, "\n\n Presione aceptar para terminar el programa ..."); 
    return -1;
		}
  return 0; 
}


/* 
	Imprime en la consola informacin del archivo de audio guardados en 'dau'.
	Tambin se le pasa el nombre del archivo para obtener el tipo de la cabecera 
	y el formato del audio, stos datos no estn guardados en la estructura DAUDIO. 
	Por ltmo, se permite pasar un mensaje a ser mostrado junto con los datos como ttulo.

	titulo: es utilizado como un ttulo que se agrega ntes del nombre del archvio de audio.
*/
void ImprDatosDeAudio(char *narch, DAUDIO *dau, char *titulo)
{
	fprintf(stdout, "\n%s: %s:\n\n  F.MUESTREO: \t%d  mues/s\n  CANALES: \t%d\n  DURACION: \t%f  seg\n  MUESTRAS: \t%d\n  MUES/CAN: \t%d\n",
		titulo, narch, dau->frec_muestreo, dau->canales, dau->duracion, dau->muestras, dau->mu_can);

  fprintf(stdout, "  TIPO: \t%s\n  FORMATO: \t%s\n  COMENTARIO: \t%s\n", 
								  mus_header_type_name(mus_sound_header_type(narch)),
									mus_data_format_name(mus_sound_data_format(narch)),
									dau->comentario);
}


/* 
	abre un archivo para salida, o sea que puede ser modificado, usando como
	datos la estructura DAUDIO, que contiene toda la info necesaria, luego imprime 
	sus daots.
*/
void AbrirAudioSalida(char* nombre, DAUDIO *datos)
{
		/* es suficiente con sta llamada para crear un audio para salida */
  datos->na = mus_sound_open_output(nombre, datos->frec_muestreo, datos->canales, 
				                            datos->formato, datos->cabecera, datos->comentario);
		/* simple comprobacin de errores */
  if (datos->na != -1)
		printf("\nAudio de salida preparado para ser usado ...");
  else 
		{
    fprintf(stderr, "%s: %s\n", nombre, strerror(errno));
    fprintf(stdout,"\n\n Presione aceptar para terminar el programa ..."); 
    getchar();
		}
}

